'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));

var CONTEXT_GET_MARKUP = 'context-get-markup';
var CONTEXT_CACHE_MARKUP = 'context-cache-markup';
var CONTEXT_IS_SERVER = 'conext-is-server';
var CONTEXT_IS_STATIC_CHILD = 'context-is-static-child';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var _StaticContent$contex;

var StaticContent = function (_Component) {
    inherits(StaticContent, _Component);

    function StaticContent(props, context) {
        classCallCheck(this, StaticContent);

        var _this = possibleConstructorReturn(this, (StaticContent.__proto__ || Object.getPrototypeOf(StaticContent)).call(this));

        var renderID = !context[CONTEXT_IS_STATIC_CHILD] && props.renderID;
        _this.state = {
            renderID: renderID,
            markup: !context[CONTEXT_IS_SERVER] && context[CONTEXT_GET_MARKUP](renderID)
        };
        if (!context[CONTEXT_IS_SERVER]) {
            _this.shouldComponentUpdate = function () {
                return false;
            };
            _this.componentWillUnmount = function () {
                return _this.context[CONTEXT_CACHE_MARKUP](renderID, _this.state.markup);
            };
        }
        return _this;
    }

    createClass(StaticContent, [{
        key: 'getChildContext',
        value: function getChildContext() {
            return defineProperty({}, CONTEXT_IS_STATIC_CHILD, true);
        }
    }, {
        key: 'render',
        value: function render() {
            var props = this.state.renderID && { 'data-render-id': this.state.renderID };
            return this.state.markup ? React__default.createElement('div', _extends({}, props, {
                dangerouslySetInnerHTML: {
                    __html: this.state.markup
                }
            })) : React__default.createElement(
                'div',
                props,
                this.props.children
            );
        }
    }]);
    return StaticContent;
}(React.Component);

StaticContent.childContextTypes = defineProperty({}, CONTEXT_IS_STATIC_CHILD, PropTypes.bool);

StaticContent.contextTypes = (_StaticContent$contex = {}, defineProperty(_StaticContent$contex, CONTEXT_GET_MARKUP, PropTypes.func), defineProperty(_StaticContent$contex, CONTEXT_CACHE_MARKUP, PropTypes.func), defineProperty(_StaticContent$contex, CONTEXT_IS_SERVER, PropTypes.bool), defineProperty(_StaticContent$contex, CONTEXT_IS_STATIC_CHILD, PropTypes.bool), _StaticContent$contex);

var _StaticRenderProvider;

var StaticRenderProvider = function (_Component) {
    inherits(StaticRenderProvider, _Component);

    function StaticRenderProvider() {
        classCallCheck(this, StaticRenderProvider);

        var _this = possibleConstructorReturn(this, (StaticRenderProvider.__proto__ || Object.getPrototypeOf(StaticRenderProvider)).call(this));

        _this.cache = {};
        return _this;
    }

    createClass(StaticRenderProvider, [{
        key: 'getMarkup',
        value: function getMarkup(renderID) {
            if (renderID in this.cache) {
                return this.cache[renderID];
            }
            var node = document.querySelector('[data-render-id="' + renderID + '"');
            if (!node) {
                //raise warning
                return null;
            }
            return node.innerHTML;
        }
    }, {
        key: 'cacheMarkup',
        value: function cacheMarkup(renderID, markup) {
            if (renderID in this.cache) {
                return;
            }
            this.cache[renderID] = markup;
        }
    }, {
        key: 'render',
        value: function render() {
            return React.Children.only(this.props.children);
        }
    }, {
        key: 'getChildContext',
        value: function getChildContext() {
            var _ref;

            return _ref = {}, defineProperty(_ref, CONTEXT_GET_MARKUP, this.getMarkup.bind(this)), defineProperty(_ref, CONTEXT_CACHE_MARKUP, this.cacheMarkup.bind(this)), defineProperty(_ref, CONTEXT_IS_SERVER, this.props.server), _ref;
        }
    }]);
    return StaticRenderProvider;
}(React.Component);

StaticRenderProvider.defaultProps = {
    server: false
};

StaticRenderProvider.childContextTypes = (_StaticRenderProvider = {}, defineProperty(_StaticRenderProvider, CONTEXT_GET_MARKUP, PropTypes.func), defineProperty(_StaticRenderProvider, CONTEXT_CACHE_MARKUP, PropTypes.func), defineProperty(_StaticRenderProvider, CONTEXT_IS_SERVER, PropTypes.bool), _StaticRenderProvider);

exports.StaticContent = StaticContent;
exports.StaticRenderProvider = StaticRenderProvider;
